module Dgrid
  module API
    class Keyword < NamedEntity
      attr_accessor :synonyms
      attr_accessor :triggers_alert
      
      option :name, String, :required     # unique for this workspace 
      option :id, String
      option :synonyms, String
      option :triggers_alert, String      # really Boolean but no such class exists!
      def initialize(options)
        parent_opts, my_opts = split_hash(options,[:id, :name])
      	super(parent_opts)
        set_members_from_hash(my_opts)

      end

      def self.db_fields
        %w(id name synonyms triggers_alert)
      end

      def to_hash
        h = super
        h.delete(:description)
        h.merge!( { :synonyms => synonyms,
                    :triggers_alert => triggers_alert
                  })
        h
      end

      def self.pluralized
        'keywords'
      end


    end
  end
end
