module Dgrid
  module API
    class Link < Entity

      attr_accessor :left_type, :left_guid, :right_type, :right_guid, :descriptoion
      attr_reader :auto_linked

      option :left_type, String, :required
      option :left_guid, String, :required
      option :right_type, String, :required
      option :right_guid, String, :required
      option :auto_linked, String # really Boolean but no such class exists!
      option :left_id, String
      option :right_id, String
      def initialize(options)
      	parent_opts, my_opts = split_hash(options,[:id, :description])
        super(parent_opts)
        @auto_linked = false
      	set_members_from_hash(options)
      end

      def self.db_fields
        %w(id description auto_linked left_type left_guid left_id right_type right_guid right_id)
      end
      
      def self.pluralized
        'links'
      end

      def to_hash
      	h = { :description => description,
              :left_type => left_type,
              :left_guid => left_guid,
              :right_type => right_type,
              :right_guid => right_guid
            }
      end
    end
  end
end
