module Dgrid
  module API
    class Person < NamedEntity
      attr_accessor :gender, :birth_date, :death_date, :ext_id

      option :name, String, :required
      option :description, String
      option :gender, :must_be_m_or_f
      option :birth_date, DateTime
      option :death_date, DateTime
      option :ext_id, String
      def initialize(options)
        parent_opts, my_opts = split_hash(options,[:id, :name, :description])
        super(parent_opts)
        set_members_from_hash(my_opts)
      end

      def self.db_fields
        %w(id name description gender birth_date death_date)
      end
      

      def self.pluralized
        'people'
      end


      def to_hash
        h = super
        
        h.merge({ :gender => gender,
                   :birth_date => birth_date,
                   :death_date => death_date,
                   :ext_id => ext_id })
      end

    end
  end
end
