module Dgrid
  module SetMembersFromHash
    def set_members_from_hash(h)
      h.each do |key, val|
        raise "non-symbolic key #{key}" unless key.is_a?(Symbol)
        member_name = "@#{key}"
        instance_variable_set(member_name, val)
      end
    end

    require 'set'
    # split a hash into two hashes whose keys are either in or not in criteria_set
    # criteria_set can be a Set or anything that can be used to construct a Set
    def split_hash(h , criteria_set)
      local_cs = criteria_set.is_a?(Set) ? criteria_set : Set.new(criteria_set)
      haves = {}
      have_nots = {} 
      h.each do |k,v|
        if local_cs.include?(k)
          haves[k] = v
        else
          have_nots[k] = v
        end
      end
      return haves, have_nots
    end

    def change_string_keys_to_symbol_keys(hash)
      result = {}
      hash.each_pair do |k,v|
        if k.is_a?(String)
          result[k.to_sym] = v
        else
          result[k] = v
        end
      end
      result
    end

  end
end
